#!/usr/bin/python

import string,re,sys
import copy

class node:
    def __init__(self,number,domain_idx,resnum):
        self.domain_idx = domain_idx
        self.resnum = resnum
        self.number=number
        self.eliminated = 0
        
    def __str__(self):
        return "[%i, (%i,%s)]" % (self.number,self.domain_idx,self.resnum)

    __repr__=__str__

    def getNumber(self):
        return self.number

class nodeList:
    def __init__(self):
        self.length = 0
        self.nodes = {}
    
    def setNode(self,number,domain_idx,resnum):
        if not self.nodes.has_key(number):
            self.length += 1
        self.nodes[number]=(node(number,domain_idx,copy.copy(resnum)))

    addNode=setNode

    def getNodeByLabel(self,number):
        return self.nodes[number]

    def __contains__(self,number):
        if self.nodes.has_key(number): return 1
        return 0

    def __len__(self):
        return self.length

    def getLabels(self):
        return self.nodes.keys()
